build-psiphon-framework.sh 7.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213
  1. #!/usr/bin/env bash
  2. set -e -u -x
  3. if [ -z ${1+x} ]; then BUILD_TAGS=""; else BUILD_TAGS="$1"; fi
  4. # Modify this value as we use newer Go versions.
  5. GO_VERSION_REQUIRED="1.11.13"
  6. # At this time, gomobile doesn't support modules
  7. export GO111MODULE=off
  8. # Reset the PATH to macOS default. This is mainly so we don't execute the wrong
  9. # gomobile executable.
  10. PATH=/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/go/bin
  11. BASE_DIR=$(cd "$(dirname "$0")" ; pwd -P)
  12. cd ${BASE_DIR}
  13. # The location of the final framework build
  14. BUILD_DIR="${BASE_DIR}/build"
  15. # Ensure go is installed
  16. which go 2>&1 > /dev/null
  17. if [[ $? != 0 ]]; then
  18. echo "Go is not installed in the path, aborting"
  19. exit 1
  20. fi
  21. VALID_IOS_ARCHS="arm64 armv7 armv7s"
  22. VALID_SIMULATOR_ARCHS="x86_64"
  23. FRAMEWORK="Psi"
  24. INTERMEDIATE_OUPUT_DIR="${BASE_DIR}/PsiphonTunnel/PsiphonTunnel"
  25. INTERMEDIATE_OUPUT_FILE="${FRAMEWORK}.framework"
  26. FRAMEWORK_BINARY="${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}/Versions/A/${FRAMEWORK}"
  27. UMBRELLA_FRAMEWORK_XCODE_PROJECT=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel.xcodeproj/
  28. # Exporting these seems necessary for subcommands to pick them up.
  29. export GOPATH=${PWD}/go-ios-build
  30. export PATH=${GOPATH}/bin:${PATH}
  31. # The GOPATH we're using is temporary, so make sure there isn't one from a previous run.
  32. rm -rf ${GOPATH}
  33. GOMOBILE_PINNED_REV=92f3b9caf7ba8f4f9c10074225afcba0cba47a62
  34. GOMOBILE_PATH=${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  35. TUNNEL_CORE_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core
  36. PATH=${PATH}:${GOPATH}/bin
  37. mkdir -p ${GOPATH}
  38. if [[ $? != 0 ]]; then
  39. echo "FAILURE: mkdir -p ${GOPATH}"
  40. exit 1
  41. fi
  42. # Symlink the current source directory into GOPATH, so that we're building the
  43. # code in this local repo, rather than pulling from Github and building that.
  44. mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs
  45. if [[ $? != 0 ]]; then
  46. echo "mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs"
  47. exit 1
  48. fi
  49. ln -s "${BASE_DIR}/../.." "${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  50. if [[ $? != 0 ]]; then
  51. echo "ln -s ../.. ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  52. exit 1
  53. fi
  54. mkdir -p ${INTERMEDIATE_OUPUT_DIR}
  55. if [[ $? != 0 ]]; then
  56. echo "FAILURE: mkdir -p ${INTERMEDIATE_OUPUT_DIR}"
  57. exit 1
  58. fi
  59. # arg: binary_path
  60. function strip_architectures() {
  61. valid_archs="${VALID_IOS_ARCHS} ${VALID_SIMULATOR_ARCHS}"
  62. ARCHS="$(lipo -info "$1" | rev | cut -d ':' -f1 | rev)"
  63. for ARCH in "${valid_archs}"; do
  64. if ! [[ "${valid_archs}" == *"$ARCH"* ]]; then
  65. echo "Stripping ARCH ${ARCH} from $1"
  66. lipo -remove "$ARCH" -output "$1" "$1"
  67. if [[ $? != 0 ]]; then
  68. echo "FAILURE: lipo $1"
  69. exit 1
  70. fi
  71. fi
  72. done
  73. return 0
  74. }
  75. # Check Go version
  76. GO_VERSION=$(go version | sed -E -n 's/.*go([0-9]\.[0-9]+(\.[0-9]+)?).*/\1/p')
  77. if [[ ${GO_VERSION} != ${GO_VERSION_REQUIRED} ]]; then
  78. echo "FAILURE: go version mismatch; require ${GO_VERSION_REQUIRED}; got ${GO_VERSION}"
  79. exit 1
  80. fi
  81. # Don't use -u, because this path points to our local repo, and we don't want it overridden.
  82. go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  83. if [[ $? != 0 ]]; then
  84. echo "FAILURE: go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  85. exit 1
  86. fi
  87. #
  88. # Get and install gomobile, using our pinned revision
  89. #
  90. go get -u golang.org/x/mobile/cmd/gomobile
  91. cd ${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  92. git checkout master
  93. git checkout -b pinned ${GOMOBILE_PINNED_REV}
  94. go install
  95. ${GOPATH}/bin/gomobile init -v -x
  96. if [[ $? != 0 ]]; then
  97. echo "FAILURE: ${GOPATH}/bin/gomobile init"
  98. exit 1
  99. fi
  100. #
  101. # gomobile bind
  102. #
  103. # Ensure BUILD* variables reflect the tunnel-core repo
  104. cd ${TUNNEL_CORE_SRC_DIR}
  105. BUILDINFOFILE="${BASE_DIR}/psiphon-tunnel-core_buildinfo.txt"
  106. BUILDDATE=$(date +%Y-%m-%dT%H:%M:%S%z)
  107. BUILDREPO=$(git config --get remote.origin.url)
  108. BUILDREV=$(git rev-parse --short HEAD)
  109. GOVERSION=$(go version | perl -ne '/go version (.*?) / && print $1')
  110. GOMOBILEVERSION=$(${GOPATH}/bin/gomobile version | perl -ne '/gomobile version (.*?) / && print $1')
  111. # see DEPENDENCIES comment in MobileLibrary/Android/make.bash
  112. cd ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  113. DEPENDENCIES=$(echo -n "{" && GOOS=darwin go list -tags "${BUILD_TAGS}" -f '{{range $dep := .Deps}}{{printf "%s\n" $dep}}{{end}}' | GOOS=darwin xargs go list -tags "${BUILD_TAGS}" -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | xargs -I pkg bash -c 'PKG=pkg && cd $GOPATH/src/$PKG && echo -n "\"$PKG\":\"$(git rev-parse --short HEAD)\","' | sed 's/,$/}/')
  114. LDFLAGS="\
  115. -s \
  116. -w \
  117. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.buildDate=${BUILDDATE} \
  118. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.buildRepo=${BUILDREPO} \
  119. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.buildRev=${BUILDREV} \
  120. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.goVersion=${GOVERSION} \
  121. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.gomobileVersion=${GOMOBILEVERSION} \
  122. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common/buildinfo.dependencies=${DEPENDENCIES} \
  123. "
  124. echo -e "${BUILDDATE}\n${BUILDREPO}\n${BUILDREV}\n" > $BUILDINFOFILE
  125. echo ""
  126. echo "Variables for ldflags:"
  127. echo " Build date: ${BUILDDATE}"
  128. echo " Build repo: ${BUILDREPO}"
  129. echo " Build revision: ${BUILDREV}"
  130. echo " Go version: ${GOVERSION}"
  131. echo " Gomobile version: ${GOMOBILEVERSION}"
  132. echo ""
  133. # We're using a generated-code prefix to workaround https://github.com/golang/go/issues/18693
  134. # CGO_CFLAGS_ALLOW is to workaround https://github.com/golang/go/issues/23742 in Go 1.9.4
  135. CGO_CFLAGS_ALLOW="-fmodules|-fblocks" ${GOPATH}/bin/gomobile bind -v -x -target ios -prefix Go -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  136. rc=$?; if [[ $rc != 0 ]]; then
  137. echo "FAILURE: ${GOPATH}/bin/gomobile bind -target ios -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  138. exit $rc
  139. fi
  140. strip_architectures "${FRAMEWORK_BINARY}"
  141. #
  142. # Do the outer framework build using Xcode
  143. #
  144. # Clean previous output
  145. rm -rf "${BUILD_DIR}"
  146. rm -rf "${BUILD_DIR}-SIMULATOR"
  147. # Build the outer framework for phones...
  148. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphoneos ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}"
  149. rc=$?; if [[ $rc != 0 ]]; then
  150. echo "FAILURE: xcodebuild iphoneos"
  151. exit $rc
  152. fi
  153. # ...and for the simulator.
  154. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphonesimulator ARCHS=x86_64 VALID_ARCHS=x86_64 ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}-SIMULATOR"
  155. rc=$?; if [[ $rc != 0 ]]; then
  156. echo "FAILURE: xcodebuild iphonesimulator"
  157. exit $rc
  158. fi
  159. # Add the simulator x86_64 binary into the main framework binary.
  160. lipo -create "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel" "${BUILD_DIR}-SIMULATOR/PsiphonTunnel.framework/PsiphonTunnel" -output "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel"
  161. rc=$?; if [[ $rc != 0 ]]; then
  162. echo "FAILURE: lipo create"
  163. exit $rc
  164. fi
  165. # Delete the temporary simulator build files.
  166. rm -rf "${BUILD_DIR}-SIMULATOR"
  167. # Jenkins loses symlinks from the framework directory, which results in a build
  168. # artifact that is invalid to use in an App Store app. Instead, we will zip the
  169. # resulting build and use that as the artifact.
  170. cd "${BUILD_DIR}"
  171. zip --recurse-paths --symlinks build.zip * --exclude "*.DS_Store"
  172. echo "BUILD DONE"